/// <reference types="react" />
/// <reference types="monaco-editor/monaco" />
/// <reference types="../../../typings/monaco" />
import * as React from 'react';
export interface IMonacoDiffEditorProps {
    context?: any;
    width?: string | number;
    height?: string | number;
    value?: string;
    original?: string;
    defaultValue?: string;
    language?: string;
    theme?: string;
    options?: object;
    editorDidMount?: (editor: any, monaco: any) => void;
    editorWillMount?: (editor: any) => void;
    onChange?: (value: any, event: any) => void;
    file?: any;
}
export interface DefaultMonacoDiffEditorProps extends IMonacoDiffEditorProps {
    width: string | number;
    height: string | number;
    value: string;
    original: string;
    defaultValue: string;
    language: string;
    theme: string;
    options: object;
    editorDidMount: (editor: any, monaco: any) => void;
    editorWillMount: (editor: any) => void;
    onChange: (value: any, event: any) => void;
}
declare class MonacoDiffEditor extends React.Component<IMonacoDiffEditorProps, {}> {
    private containerElement;
    private __current_value;
    private __current_original;
    private editor;
    private __prevent_trigger_change_event;
    static defaultProps: Partial<DefaultMonacoDiffEditorProps>;
    constructor(props: any);
    componentDidMount(): void;
    componentDidUpdate(prevProps: any): void;
    componentWillUnmount(): void;
    editorWillMount(monaco: any): void;
    editorDidMount(editor: any, monaco: any): void;
    afterViewInit: () => void;
    protected create(options: any, override?: monaco.editor.IEditorOverrideServices): any;
    updateModel(value: any, original: any): void;
    initMonaco(): void;
    destroyMonaco(): void;
    assignRef: (component: any) => void;
    render(): JSX.Element;
}
export default MonacoDiffEditor;
