/// <reference types="react" />
/// <reference types="monaco-editor/monaco" />
/// <reference types="../../../typings/monaco" />
import * as React from 'react';
export interface IMonacoEditorOwnProps {
    context?: any;
    width?: string | number;
    height?: string | number;
    value?: string;
    defaultValue?: string;
    language?: string;
    theme?: string;
    options?: object;
    editorDidMount?: (editor: any, monaco: any) => void;
    editorWillMount?: (editor: any) => void;
    onChange?: (value: any, event: any) => void;
    uri: string;
}
export interface DefaultMonacoEditorProps extends IMonacoEditorOwnProps {
    width: string | number;
    height: string | number;
    value: string;
    defaultValue: string;
    language: string;
    theme: string;
    options: object;
    editorDidMount: (editor: any, monaco: any) => void;
    editorWillMount: (editor: any) => void;
    onChange: (value: any, event: any) => void;
}
export declare type IMonacoEditorApiProps = {
    subscribeToMore?: Function;
    openDocumentMutate?: Function;
    initializeEditor: any;
    hoverMutate?: Function;
    changeDocumentMutate?: Function;
    completionMutate?: Function;
    formattingMutate?: Function;
    referenceMutate?: Function;
    symbolMutate?: Function;
    definitionMutate?: Function;
    closeMutate?: Function;
};
export declare type IMonacoEditorProps = IMonacoEditorOwnProps & IMonacoEditorApiProps;
declare class MonacoEditor extends React.Component<IMonacoEditorProps, {}> {
    private containerElement;
    private __current_value;
    private editor;
    private __prevent_trigger_change_event;
    private subscription;
    private capabilities;
    private registeredProviders;
    constructor(props: any);
    static defaultProps: DefaultMonacoEditorProps;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: any): void;
    componentDidUpdate(prevProps: any): void;
    componentWillUnmount(): void;
    editorWillMount(monaco: any): void;
    editorDidMount(editor: any, monaco: any): void;
    afterViewInit: () => void;
    protected create(options: any, override?: monaco.editor.IEditorOverrideServices): any;
    initMonaco(): void;
    destroyMonaco(): void;
    assignRef: (component: any) => void;
    render(): JSX.Element;
}
export default MonacoEditor;
